--[[----------------------------------------------------------------------------
################################################################################
#                                                                              #
#                        Sponsorowana Bramka Omnix                             #
#                                                                              #
#  wersja 1.42/Konnekt                                                         #
#  Ostatnie zmiany: 23.09.2005 by mls / 03.11.2005 by rysi3k                   #
#  modyfikacje: rysi3k , Q3KinG                                                #
#                                                    (c) 2005 mls <mls@o2.pl>  #
#                                                                              #
################################################################################

Dziennik zmian:
  * 2005-11-26* Q3KinG *
	+ dzielenie SMSow na czesci 110 znakowe (zmiana na stronie eraomnix)
  * 2005-11-25* Q3KinG *
	+ wybor dolaczania podpisu przy dzieleniu SMSa na czesci (do kazdej 
	  wiadomosci lub tylko do ostatniej)
	+ poprawione dzielenie SMSow (znalazlem blad w mojej poprzedniej modyfikacji
	  skryptu)
	+ dzielenie SMSow na czesci 85 znakowe (zmiana na stronie eraomnix)
  * 2005-11-06* Q3KinG *
	+ donanie drugiego konta (lecz, aby koysta z niego nalezy zaznaczy opcje
	  "Wylij wiadomo z drugiego konta" i zrestartowac Konnekta)
  * 2005-11-01 * rysi3k *
      + zmienienie teksw po wysniu z "pozostao X SMS" na proste "X SMSw"
      + poprawa wywietlania zapytania o to czy wysylac MMSem, teraz nie powinien
        pojawia si bd "Bd w ustawieniach..."
  * 2005-09-23 *
  	+ poprawione bdne wywietlanie komunikatu bdu :)
  * 2005-09-22 *
  	+ poprawiony may bd mogcy zwraca komunikat "attempt to concat..."
  * 2005-09-16 *
  	+ zmiana sposobu dostpu do bramki - teraz wykorzystuje SMS API Omnix'a
  * 2005-09-01 *
      + poprawka usuwajca znak "+" przy wysyaniu wiadomoci MMS
  * 2005-08-31 *
  	+ dzielenie wiadomoci na czci (maksymalnie 8)
	+ moliwo wysania wiadomoci jako MMS
  * 2005-08-30 *
  	+ dodano funkcj wylogowania z serwisu Era Omnix w celu usunicia
	  ciasteczka JSESSIONID
	+ usuwanie znaku "+" z pocztku numeru odbiorcy
	
Testowano na:
  * Konnekt 0.6.22.137
  * SMS.dll 1.8.2.0

--------------------------------------------------------------------------------

Cao kodu niniejszego skryptu jest autorstwa osoby wymienionej w ramce powyej
Skrypt rozprowadzany jest na zasadach licencji Creative Commons
                                  http://creativecommons.org/licenses/by/2.0/pl/

----------------------------------------------------------------------------]]--

version = 'OS_1.42/20050923';
oerrors = {'awaria systemu', 'uytkownik nieautoryzowany', 'dostp zablokowany', '?', 'bd skadni', '?', 'wyczerpany limit', 'bdny adres odbiorcy', 'wiadomo zbyt duga', 'brak wymaganej liczby etonw'};
temp = {};

-- funkcja do odmiany tekstu na wlasciwa forme
function num_text(number, text_0, text_1, text_2)
	if number == 1 then return text_1; end;
	dec_dig = math.mod(number, 10);
	hun_dig = math.mod(number, 100);
	if ((dec_dig <= 1) or (dec_dig > 4) or (hun_dig > 10 and hun_dig < 20)) then return text_0; else return text_2; end;
end;

-- funkcja wysya zapytanie do serwera omnix
function era_request(url)
	 hSession = InternetOpen("Mozilla/5.0 (MLS/Konnekt SMS API)");
	hConnect = InternetConnect(hSession, "www.eraomnix.pl", 80, "", "");
	if hSession == 0 or hConnect == 0 then setError("Problem z nawizaniem poczenia!"); end;
	hRequest = HttpOpenRequest(hConnect, "GET", url, '', 0x00200000);
	if not HttpSendRequest(hRequest, "") then setError("Problem z poczeniem!"); return 0; end;
	era_info = HttpQueryInfo(hRequest, 33);
	InternetCloseHandle(hRequest);
	InternetCloseHandle(hConnect);
	InternetCloseHandle(hSession);
	return era_info;
end;

-- funkcja dzielenia cigu znakw na czci
function era_splitString(string, length)
	split = {};
	strlen = string.len(string);
	for i=1, strlen, length do
		table.insert(split, string.sub(string, i, i+length-1));
	end;
	return split;
end;

-- funkcja dzielenia SMSa na czci
function era_divideMessage(msgTable)
	if msgTable.from ~= "" then
		fullMsg = string.len(msgTable.msg.."/"..msgTable.from);
	else
		fullMsg = string.len(msgTable.msg);
	end;
	if fullMsg > 110 then
		if msgTable.pod == "1" then
			if msgTable.from ~= "" then
				partLen = 105-string.len("/"..msgTable.from);
				msgPart = era_splitString(msgTable.msg, partLen);
			else
				msgPart = era_splitString(msgTable.msg, 105);
			end;
		else
			msgTable.msg = msgTable.msg.."/"..msgTable.from;
			msgPart = era_splitString(msgTable.msg, 105);
		end;
		return msgPart;
	else
		return false;
	end;
end;

-- wlasciwa funkcja skryptu - wyslanie wiadomosci SMS
function sendSMS(SMS)
	SMS.to = preg_replace("/^[+]/", "", SMS.to);
	setInfo("mls sms script version: "..version);
	send_as_mms = false;
	if string.len(SMS.msg)>250 and SMS.omnxMMS == "0" then
        send_as_mms = confirm("Wiadomo ma ponad 250 znakw - czy sprbowa\nwysa j jako MMS?", "Informacja");
        end;
	if SMS.omnxMMS == "0" and send_as_mms == false then
		setInfo("Wysyanie wiadomoci SMS");
		msgParts = era_divideMessage(SMS);
		if msgParts ~= false then
			if SMS.omnxWarnMulti == "1" then
				if confirm("Wiadomo zostanie podzielona na "..table.getn(msgParts).." czci, co\nzuyje analogiczn liczb SMSw z bramki.\nKontynuowa wysyanie?", "Uwaga!") then
					canSendMulti = true;
				else
					canSendMulti = false;
				end;
			else
				canSendMulti = true;
			end;
			if canSendMulti == true then
				for partNr=1, table.getn(msgParts) do
					partMsg = "["..tostring(partNr).."/"..tostring(table.getn(msgParts)).."]"..msgParts[partNr];
					if SMS.from ~= "" then
						if SMS.pod == "1" then
							partMsg = partMsg.."/"..SMS.from;
						end;
					end;
					setInfo("Wysyam cz "..tostring(partNr).." z "..tostring(table.getn(msgParts)).."...");
					if SMS.kon == "1" then
						era_location = era_request("/msg/api/do/tinker/sponsored?success=localhost&failure=localhost&login="..SMS.omnxLoginD.."&password="..urlEncode(SMS.omnxPassD).."&number="..SMS.to.."&message="..urlEncode(partMsg).."&mms=false");
					else
						era_location = era_request("/msg/api/do/tinker/sponsored?success=localhost&failure=localhost&login="..SMS.omnxLogin.."&password="..urlEncode(SMS.omnxPass).."&number="..SMS.to.."&message="..urlEncode(partMsg).."&mms=false");
					end;
				end;
				if preg_match('/X-ERA-error=([0-9]+)/', era_location, temp) and temp[1] ~= '0' then
					setError("Bd - "..oerrors[tonumber(temp[1])]);
				else
					preg_match('/X-ERA-counter=([0-9]+)/', era_location, temp);
					setSuccess(temp[1].." SMSy do wykorzystania.");
				end;
			else
				setError("Wysyanie anulowane ze wzgldu na dugo wiadomoci.");
			end;
		else
			if SMS.from ~= "" then
				SMS.msg = SMS.msg.."/"..SMS.from;
			end;
			if SMS.kon == "1" then
				era_location = era_request("/msg/api/do/tinker/sponsored?success=localhost&failure=localhost&login="..SMS.omnxLoginD.."&password="..urlEncode(SMS.omnxPassD).."&number="..SMS.to.."&message="..urlEncode(SMS.msg).."&mms=false");
			else
				era_location = era_request("/msg/api/do/tinker/sponsored?success=localhost&failure=localhost&login="..SMS.omnxLogin.."&password="..urlEncode(SMS.omnxPass).."&number="..SMS.to.."&message="..urlEncode(SMS.msg).."&mms=false");
			end;
			if preg_match('/X-ERA-error=([0-9]+)/', era_location, temp) and temp[1] ~= '0' then
				setError("Bd - "..oerrors[tonumber(temp[1])]);
			else
				preg_match('/X-ERA-counter=([0-9]+)/', era_location, temp);
				setSuccess(temp[1].." SMSy do wykorzystania.");
			end;
		end;			
	elseif SMS.omnxMMS == "1" or send_as_mms == true then
		setInfo("Wysyanie wiadomoci MMS");
		if SMS.kon == "1" then
			era_location = era_request("/msg/api/do/tinker/sponsored?success=localhost&failure=localhost&login="..SMS.omnxLoginD.."&password="..urlEncode(SMS.omnxPassD).."&number="..SMS.to.."&message="..urlEncode(SMS.msg).."&mms=true");
		else
			era_location = era_request("/msg/api/do/tinker/sponsored?success=localhost&failure=localhost&login="..SMS.omnxLogin.."&password="..urlEncode(SMS.omnxPass).."&number="..SMS.to.."&message="..urlEncode(SMS.msg).."&mms=true");
		end;
		if preg_match('/X-ERA-error=([0-9]+)/', era_location, temp) and temp[1] ~= '0' then
			setError("Bd - "..oerrors[tonumber(temp[1])]);
		else
			preg_match('/X-ERA-counter=([0-9]+)/', era_location, temp);
			setSuccess(temp[1].." MMSy do wykorzystania.");
		end;
	else
		setError("Bd w ustawieniach skryptu - win za to ponosi Konnekt - sprbuj zmieni ustawienie opcji \"Wylij jako MMS\" i sprbuj ponownie.");
	end;
end;
